
#include <string>
#include <iostream>
#include "XrdClient/XrdClient.hh"
#include "XrdClient/XrdClientAdmin.hh"

#define READ_LEN 1024
int main(int argc, const char * argv[]) {
    if (argc != 3) {
        std::cout << "Usage: " << argv[0] << " URL HOST" << std::endl;
        return 1;
    }
    const char * url = argv[1];
    const char * host = argv[2];
    XrdClient client(url);
    XrdClientAdmin admin(url);
    admin.Connect();

    XrdClientVector<XrdClientLocate_Info> resp;

    std::string path(url);
    size_t loc = path.find("://");
    if (loc == string::npos) {
      std::cout << "Not a URL: " << url;
      return 2;
    }
    loc = path.find("/", loc+3);
    std::string server(path.substr(0, loc+1));
    path = path.substr(loc+1);
    if (!admin.Locate((kXR_char*)path.c_str(), resp)) {
      std::cout << "Unable to find path " << path << " at server " << server
        << std::endl;
    }

    while (resp.GetSize()) {
       cout << "Location: " << resp.Pop_front().Location << std::endl;
    }

    return 0;

/*
    kXR_unt16 openOpt = 0;
    openOpt |= kXR_open_read;
    kXR_unt16 openMode = kXR_or | kXR_gr | kXR_ur | kXR_uw;

    if (client.Open(openMode, openOpt, false) == false) {
        printf("Unable to open URL %s.\n", url);
        return 2;
    }
    char * buf = NULL;
    buf = (char *)malloc(READ_LEN*sizeof(char));
    if (buf == NULL) {
        printf("Unable to allocate necessary memory for test.\n");
        return 3;
    }
    int bytes = client.Read(buf, 0, READ_LEN);
    if (bytes != READ_LEN) {
        printf("Read returned %i bytes when we expected %i.\n", bytes, READ_LEN);
        return 4;
    }
    if (!client.Close()) {
        printf("Unable to close file.\n");
        return 5;
    }
*/
}

