
#include <stdio.h>
#include "XrdClient/XrdClient.hh"

#define READ_LEN 1024
int main(int argc, const char * argv[]) {
    if (argc != 2) {
        printf("usage: %s URL\n", argv[0]);
        return 1;
    }
    const char * url = argv[1];
    XrdClient client(url);
    kXR_unt16 openOpt = 0;
    openOpt |= kXR_open_read;
    kXR_unt16 openMode = kXR_or | kXR_gr | kXR_ur | kXR_uw;

    if (client.Open(openMode, openOpt, false) == false) {
        printf("Unable to open URL %s.\n", url);
        return 2;
    }
    char * buf = NULL;
    buf = (char *)malloc(READ_LEN*sizeof(char));
    if (buf == NULL) {
        printf("Unable to allocate necessary memory for test.\n");
        return 3;
    }
    int bytes = client.Read(buf, 0, READ_LEN);
    if (bytes != READ_LEN) {
        printf("Read returned %i bytes when we expected %i.\n", bytes, READ_LEN);
        return 4;
    }
    if (!client.Close()) {
        printf("Unable to close file.\n");
        return 5;
    }
}

